#!/bin/sh
##################################################################################################
#
#     ChangeFileOwner.sh
#     処理概要：カキコまっぷで使用されるディレクトリ・ファイルのオーナーを設定します。
#     作成日/作成者：2006/08/28 (IIS) N.Soma
#     バージョン：1.0.0
#     注意事項：スーパーユーザで起動してください。
#
#     引数
#      $1：Apacheのユーザ名
#      $2：Apacheのグループ名
#
#  Copyright (c) 2006 Iwate Information System Co.,Ltd. All Rights Reserved.
#  You may see the License at LICENSE_EN.txt(English) or LICENSE_JA.txt(Japanese).
#
##################################################################################################

APACHE_USER=$1;
APACHE_GROUP=$2;

if [ $# -ne 2 ] ; then
    echo -e "引数を設定してください";
    echo -e "\t引数1:Apache User";
    echo -e "\t引数2:Apache Group";
    exit 1;
fi

chown -R apache:apache ./conf
chown -R apache:apache ./contents_temp
chown -R apache:apache ./html
chown -R apache:apache ./kakiko-bin
chown -R apache:apache ./kakikolib
chown -R apache:apache ./log
chown -R apache:apache ./smarty
 

echo "終了しました。";
exit 0;
