<?php
/**
* userauth.php 処理概要：認証処理
* PHP versions：4.4.2
* @パッケージ：-
* @作者：(IIS)J.Hashimoto
* @作成日/作成者：2006/09/01 (IIS)J.Hashimoto
* @更新日/更新者：
* @バージョン：1.0.0
*
*  Copyright (c) 2006 Iwate Information System Co.,Ltd. All Rights Reserved.
*  You may see the License at LICENSE_EN.txt(English) or LICENSE_JA.txt(Japanese).
*/ 

if (!defined("DIRECTORY_NAME")) {
require_once("../DefineDirectryName.php");                          // マップ別定数定義
}

require_once("Auth/Auth.php");                                     // Pear:Auth
require_once("HTML/QuickForm.php");                                // Pear:HTML_QuickForm
require_once("HTML/QuickForm/Renderer/ArraySmarty.php");           // QuickForm とsmarty を連携
require_once("class/common/KakikoSmarty.class.php");               // カキコまっぷSmarty
require_once("class/common/KakikoTableName.class.php");            // マップ別テーブル名称取得クラス
require_once("class/xml/ReadResource.class.php");                  // リソースファイル読込み
require_once("function/KakikoCheckCallback.php");                  // チェックコールバック
require_once("function/KakikoLog.php");	                         // ログ出力処理
require_once("kakikomap/require/common/".DIRECTORY_NAME."_settingRead.php");    // ユーザ用設定ファイル
//require_once("kakikomap/require/db/".DIRECTORY_NAME."_kakikouserinfo.php");    // 一般ユーザ接続情報
require_once("kakikomap/require/db/".DIRECTORY_NAME."_userinfoRead.php");    // 一般ユーザ接続情報

// 出力のバッファリングを有効にする
ob_start();

// セッション開始
session_start();

// smarty インスタンス化
$o_smarty = new KakikoSmarty();

// エラーハンドラ設定
PEAR::setErrorHandling(PEAR_ERROR_CALLBACK, "errHandle");

// 認証オプション設定
$params = array(
	"dsn" => DBTYPE."://".DBUSER.":".DBPASS."@".DBHOST."/".DBNAME, 
										// PEAR::DB参照
	"table" => DIRECTORY_NAME."_usertable",  		// テーブル名
	"usernamecol" => "userid", 			// ユーザー名にあたるカラム名
	"passwordcol" => "password", 		// パスワードにあたるカラム名
	"db_fields" => "*",
	"cryptType" => "md5", 				// 暗号化(デフォルトはMD5)
	"sessionName"=>"_auth".DIRECTORY_NAME."usersession"
);
// 認証インスタンス生成
$o_auth = new Auth("DB", $params, "createLoginPage", true);

// ログイン、ログアウト、ログイン失敗の際に呼ばれる関数を設定
//$o_auth->setLoginCallback("LoginCallback");
//$o_auth->setFailedLoginCallback("FailedLoginCallback");
//$o_auth->setLogoutCallback("LogoutCallback");

// ログイン可能な時間を設定(0はデフォルトで無制限)
//$o_auth->setExpire(0);

// アイドル時間を設定(0はデフォルトで無制限)
//$o_auth->setIdle(0);


// 認証開始
$o_auth->start();
// 結果を判別
if ($o_auth->getAuth()){
	// 認証OK(セッション情報へIDの設定等をする)
//	print "認証OK"."<BR>";
	// ユーザID
	$_SESSION[DIRECTORY_NAME.'_userid'] = $o_auth->getUsername();
	// ユーザ名
	$_SESSION[DIRECTORY_NAME.'_username'] = $o_auth->getAuthData("username");
	// ユーザ種別
	$_SESSION[DIRECTORY_NAME.'_usertype'] = $o_auth->getAuthData("usertype");
	// テーブル名オブジェクト
	$_SESSION[DIRECTORY_NAME.'_tablename'] = serialize(new KakikoTableName("", DIRECTORY_NAME));
}else{
//	print "認証ERR"."<BR>";
	exit(0);
}
//session_regenerate_id(); // セッション偽装防止


function createLoginPage($username, $status){
	global $o_smarty;
	$err = "";

	// リソースファイル読込みインスタンス
	$o_resource = new ReadResource(RESOURCE_CONTENTS, DIRECTORY_NAME);

	switch($status){
		case AUTH_IDLED :	

		case AUTH_EXPIRED :	
			$err = mbConvertEncoding($o_resource->getValue("G06001M011"), "SJIS");
			break;
		case AUTH_WRONG_LOGIN :	
			$err = mbConvertEncoding($o_resource->getValue("G06001M012"), "SJIS");
			break;
	}
	$o_smarty->assign("err", $err);	

	// PEAR::QuickFormの作成
	$queryString = "";
	if($_SERVER['QUERY_STRING'] != ""){
		$queryString = "?".$_SERVER['QUERY_STRING'];
	}
	$o_form = new HTML_QuickForm("loginForm", "post", $_SERVER['PHP_SELF'].$queryString, "_self");

	// FORMエレメントの生成
    $o_form->addElement("header", "header", mbConvertEncoding($o_resource->getValue("G06001L009"), "SJIS"));
	$o_form->addElement("text", "username", mbConvertEncoding($o_resource->getValue("G06001L005"), "SJIS"),
								array("size"=>10, "maxlength"=>16));
	$o_form->addElement("password", "password", mbConvertEncoding($o_resource->getValue("G06001L006"), "SJIS"),
								array("size"=>10, "maxlength"=>20));
	$o_form->addElement("submit", "submit", mbConvertEncoding($o_resource->getValue("G06001L007"), "SJIS"));
	$o_form->addElement("reset", "reset", mbConvertEncoding($o_resource->getValue("G06001L008"), "SJIS"));
//	$o_form->setRequiredNote("");
//	$o_form->setJsWarnings("以下のエラーが発生","エラー項目を修正してください。");

	// 独自チェックルールの定義
	$o_form->registerRule('maxlength_valid', 'callback', 'check_maxlength_valid');
	$o_form->registerRule('minlength_valid', 'callback', 'check_minlength_valid');
	
	// チェックルール(alphanumericは全角半角を区別しないようなので regexを使用するべき？)

	$o_form->addRule("username", mbConvertEncoding($o_resource->getValue("G06001M004"), "SJIS"), "required", null, "client");
	$o_form->addRule("username", mbConvertEncoding($o_resource->getValue("G06001M005"), "SJIS"), "maxlength_valid",	16);
	$o_form->addRule("username", mbConvertEncoding($o_resource->getValue("G06001M006"), "SJIS"), "regex", "/^[a-zA-Z0-9]+$/", "client");
	$o_form->addRule("password", mbConvertEncoding($o_resource->getValue("G06001M007"), "SJIS"), "required", null, "client");
	$o_form->addRule("password", mbConvertEncoding($o_resource->getValue("G06001M008"), "SJIS"), "minlength_valid",	8);
	$o_form->addRule("password", mbConvertEncoding($o_resource->getValue("G06001M008"), "SJIS"), "maxlength_valid",	20);
	$o_form->addRule("password", mbConvertEncoding($o_resource->getValue("G06001M009"), "SJIS"), "regex", "/^[a-zA-Z0-9,_-]+$/", "client");

	// validate
	if ($o_form->validate()) {
		// FORM認証OK

		// QuickForm_Renderer の設定
		$o_renderer =& new HTML_QuickForm_Renderer_ArraySmarty($o_smarty);
		$o_form->accept($o_renderer);
		$o_smarty->assign("form",$o_renderer->toArray());
		// 表示
		$o_smarty->display(DIRECTORY_NAME."/mobilelogin.tpl");

	}else{
//if (isset($_POST['submit']))
//print "FORM認証NG"."<BR>";
		// FORM認証NG（※初期表示時はFORM未検証のため以下の処理。未確認です・・・）

		// QuickForm_Renderer の設定
		$o_renderer =& new HTML_QuickForm_Renderer_ArraySmarty($o_smarty);
		$o_form->accept($o_renderer);
		$o_smarty->assign("form",$o_renderer->toArray());
		// 表示
		$o_smarty->display(DIRECTORY_NAME."/mobilelogin.tpl");
	}
}

function errHandle($err){
	global $LOG;
	$LOG->err($err->getMessage);
}

?>
